#include <windows.h>
#include <stdio.h>
#include "flightData.h"
#include "debuggr.h"
#include "phyconst.h"

HANDLE gSharedMemHandle = NULL;
void* gSharedMemPtr = NULL;

int main (void)
{
FlightData* flightData;

   gSharedMemHandle = OpenFileMapping(FILE_MAP_READ, TRUE, "FalconSharedMemoryArea");

   if (gSharedMemHandle)
   {
      gSharedMemPtr = MapViewOfFile(gSharedMemHandle, FILE_MAP_READ, 0, 0, 0);
   }
   else
   {
      printf ("Unable to open file. Is Falcon Running?\n");
      exit (0);
   }

   flightData = (FlightData*)gSharedMemPtr;

   InitDebug(DEBUGGER_TEXT_MODE);

   while (TRUE)
   {
      MonoLocate (0,0);
      MonoPrint ("X:     %15.2f Y:      %15.2f Z:     %15.2f\n", flightData->x, flightData->y, flightData->z);
      MonoPrint ("XDot:  %15.2f YDot:   %15.2f ZDot:  %15.2f\n", flightData->xDot, flightData->yDot, flightData->zDot);
      MonoPrint ("Alpha: %15.2f Beta:   %15.2f Gamma: %15.2f\n", flightData->alpha*RTD, flightData->beta*RTD,
         flightData->gamma*RTD);
      MonoPrint ("Theta: %15.2f Phi:    %15.2f Psi:   %15.2f\n", flightData->pitch*RTD, flightData->roll*RTD,
         flightData->yaw*RTD);
      MonoPrint ("Mach:  %15.2f Kias:   %15.2f Vt:    %15.2f\n", flightData->mach, flightData->kias, flightData->vt);
      MonoPrint ("Gs:    %15.2f Nozzle: %15.2f FTIT:  %15.2f\n", flightData->gs, flightData->nozzlePos, flightData->ftit);
      MonoPrint ("IFuel: %15.2f EFuel:  %15.2f Flow:  %15.2f\n", flightData->internalFuel, flightData->externalFuel, flightData->fuelFlow);
      MonoPrint ("RPM:   %15.2f Gear:   %15.2f Brake: %15.2f\n", flightData->rpm, flightData->gearPos, flightData->speedBrake);
      MonoPrint ("EPU:   %15.2f Oil:    %15.2f Lights:%#15X\n", flightData->epuFuel, flightData->oilPressure, flightData->lightBits);
   }

   // Close shared memory area
   if (gSharedMemPtr)
   {
      UnmapViewOfFile(gSharedMemPtr);
      gSharedMemPtr = NULL;
   }
   CloseHandle (gSharedMemHandle);

   return 1;
}

